function load_objects()
  -- object "enums"
  VECTOR2        = 101
  STATE          = 102
  STATE_MANAGER  = 103
  TIMER          = 104
  MASTER_TIMER   = 105
  KEY            = 106
  BUTTON         = 107 
  KEYBOARD       = 108
  EVENT          = 109
  EVENT_MANAGER  = 110
  BBOX           = 111
  BTRI           = 112
  MOUSE_INPUT    = 113
  MENU_ENTRY     = 114
  MENU           = 115
  SOUND_EFFECT   = 116
  COLOR_PALETTE  = 117
  TILE           = 118
  TILE_MAP       = 119
  TILE_TYPE      = 120   -- tile type enums in tile_types.lua
  TILE_CHUNK     = 121
  CAMERA2D       = 122
  PHYS_POINT     = 123
  PHYS_STEER     = 124
  HERO					 = 125
  MAP_POINT      = 126
  COLLIDER       = 127
  GUN            = 128
  BULLET         = 129
  FLOCK          = 130
  BOID           = 131
  MAP_BODY       = 132
  CURVE          = 133
  
  -- object tables
  vector2 = require('objects/vector2')
  state = require('objects/state')
  state_manager = require('objects/state_manager')
  
  timers = require('objects/timers')
  timer, master_timer = timers[1], timers[2]
  
  --local keyboard_objects = require('objects/keyboard')
  --key, button, keyboard = keyboard_objects[1], keyboard_objects[2], keyboard_objects[3]
  
  events = require('objects/events')
  event, event_manager = events[1], events[2]
  
  bbox = require('objects/bbox')  -- bounding box
  btri = require('objects/btri')  -- bounding triangle
  
  mouse_input = require('objects/mouse_input')
  
  local menu_objects = require('objects/menu')
  menu_entry, menu = menu_objects[1], menu_objects[2]
  
  sound_effect = require('objects/sound_effect')
  
  --color_palette = require('objects/color_palette')
  tile_types = require('objects/tile_types')
  tile = require('objects/tile')
  tile_chunk = require("objects/tile_chunk")
  tile_gradient = require('objects/tile_gradient')
  tile_palette = require('objects/tile_palette')
  tile_layer = require('objects/tile_layer')
  tile_map = require('objects/tile_map')
  level_map = require('objects/level_map')
  level = require('objects/level')
  
  --[[
  t_walk = tile_types[T_WALK]       -- general walkable tile
  t_wall = tile_types[T_WALL]       -- general wall tile
  t_flash = tile_types[T_FLASH]   -- changes colour
  ]]--
  
  
  camera2d = require("objects/camera2d")
  
  physics = require("objects/physics")
  
  cubic_spline = require('objects/cubic_spline')
  
  hero = require('objects/hero')
  
  map_point = require('objects/map_point')
  map_body = require('objects/map_body')
  
  level_collider = require('objects/level_collider')
  collider = require('objects/collider')
  
  gun = require('objects/gun')
  bullet = require('objects/bullet')
  
  flock = require('objects/flock')
  boid = require('objects/boid')
  
  curve = require('objects/curve')
  
  ray = require('objects/ray')
  sonar_gun = require('objects/sonar_gun')
  
end













