
--##########################################################################--
--[[----------------------------------------------------------------------]]--
-- level object
--[[----------------------------------------------------------------------]]--
--##########################################################################--
local level = {}
level.table = 'level'
level.master_timer = nil
level.camera = nil
level.level_map = nil
level.collider = nil
level.mouse = nil

local level_mt = { __index = level }
function level:new()
  local level = setmetatable({}, level_mt)
  level.master_timer = master_timer:new()
  
  return level
end

function level:set_camera(camera)
  self.camera = camera
end

function level:set_level_map(level_map)
  self.level_map = level_map
end

function level:set_collider(level_collider)
  self.collider = level_collider
end

function level:get_collider()
  return self.collider
end

function level:set_mouse(mouse_input)
  self.mouse = mouse_input
end

function level:get_mouse()
  return self.mouse
end

function level:get_camera()
  return self.camera
end

function level:get_master_timer()
  return self.master_timer
end

function level:get_level_map()
  return self.level_map
end



function level:keypressed(key)
  if key == 'k' then
    state.level:get_level_map().collider:remove_object(state.bbox)
  end
end
function level:keyreleased(key)
end
function level:mousepressed(x, y, button)
  if self.mouse then
    self.mouse:mousepressed(x, y, button)
  end
end
function level:mousereleased(x, y, button)
  if self.mouse then
    self.mouse:mousereleased(x, y, button)
  end
end


------------------------------------------------------------------------------
function level:update(dt)
  self.master_timer:update(dt)
  
  if self.level_map then
    self.level_map:update(dt)
  end
  
  if self.camera then
    self.camera:update(dt)
  end
  
end

------------------------------------------------------------------------------
function level:draw()

  if self.level_map then
    self.level_map:draw()
  end
  
end

return level










