local first_state = state:new()
first_state.label = 'string'
first_state.keyboard_layout = 'first_state'

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      INPUT
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.keypressed(key)
end
function first_state.keyreleased(key)
end
function first_state.mousepressed(x, y, button)
  if button == 'l' then
    menu:activate()
  end
end
function first_state.mousereleased(x, y, button)
end

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      LOAD
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.load(resolutions)
  lg.setBackgroundColor(255, 255, 255 ,255)
  events = event_manager:new()
  
  -- menu/sound test
  menu = menu:new(100, 200, 300, 400, courier_small)
  menu:add_entry('hello', function() 
                            print('hello')
                          end)
                          
  menu:add_entry('FULLSCREEN', function()
																 local func = function()
																 	 FULLSCREEN = true
																 	 RANDCOLOUR = true
																 	 local width = resolutions[1].width
																 	 local height = resolutions[1].height
																	 lg.resize_window(width, height)
																	 invaders:load_next_state(str)
																 end
																 
																 event:new(events, {func, 0.1}, 0.5)
																 menu.hover_sound:disable()
															end)
					
  for _,v in ipairs(resolutions) do
  	
    local width, height = v.width, v.height
    local str = width..' x '..height
    
    local action = function()
                     local func = function()
                       lg.resize_window(width, height)
                       invaders:load_next_state(str)
                     end
                     
                     event:new(events, {func, 0.1}, 0.5)
                     menu.hover_sound:disable()
                   end
                   
    menu:add_entry(str, action)
  end
  
  -- just skip to the next state right now
  local action = function()
                   local func = function()
                     lg.resize_window(SCR_WIDTH, SCR_HEIGHT)
                     invaders:load_next_state(str)
                   end
                   
                   event:new(events, {func, 0}, 0)
                   menu.hover_sound:disable()
                 end
                   
  lg.resize_window(SCR_WIDTH, SCR_HEIGHT)
  invaders:load_next_state()
  
  
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      UPDATE
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.update(dt)
  events:update(dt)
  menu:update(dt)
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--     DRAW
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function first_state.draw()
  menu:draw()
end


return first_state