local level1_game_state = state:new()
level1_game_state.label = 'level1_game'
level1_game_state.keyboard_layout = 'second_state'

local state = level1_game_state

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      INPUT
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function level1_game_state.keypressed(key)
  if key == " " then
    level1_game_state.hero:shoot_sonar()
  end
end
function level1_game_state.keyreleased(key)
end
function level1_game_state.mousepressed(x, y, button)
  state.level:mousepressed(x, y, button)
end
function level1_game_state.mousereleased(x, y, button)
  state.level:mousereleased(x, y, button)
end

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      LOAD
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function level1_game_state.load(level)  
  level:set_mouse(MOUSE_INPUT)
  
  local cpos = level:get_camera():get_center()
  
  --local map = level:get_level_map()
  
  local hero_pos = level:get_camera():get_center()
  local hero = hero:new(level, hero_pos)
 
  
  state.level = level
  state.camera = level:get_camera()
  state.hero = hero
  state.cpos = cpos
  
  --hero:explode()
end


--##########################################################################--
--[[----------------------------------------------------------------------]]--
--      UPDATE
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function level1_game_state.update(dt)
  local level = state.level
  level:update(dt)

  -- camera movement test
  --[[
  local speed = 400
  local camera = level:get_camera()
  local cpos = state.cpos
  if love.keyboard.isDown('w') then
    cpos.y = cpos.y - speed * dt
  end
  if love.keyboard.isDown('s') then
    cpos.y = cpos.y + speed * dt
  end
  if love.keyboard.isDown('a') then
    cpos.x = cpos.x - speed * dt
  end
  if love.keyboard.isDown('d') then
    cpos.x = cpos.x + speed * dt
  end ]]--
  
  state.hero:update(dt)
  state.camera:set_target(state.hero:get_camera_target())
  
  
  --[[
  -- animation test
  local mpos = mouse:get_position()
  mpos = mpos + cpos
  local tmap = level:get_level_map():get_tile_map_at_position(mpos)
  local tile = tmap:get_tile_at_position(mpos)
  t = t or 0
  t = t + 3*dt
  f = 0.5 + 0.5 * math.sin(t)
  local nb = tile.neighbours
  for i=1,#nb do
    local tile = nb[i]
    tile:set_quad(tile.gradient:get_quad(0.5 + 0.5 * math.sin(t + 0.1 * i)))
  end
  tile:set_quad(tile.gradient:get_quad(f))
  ]]--
end
  

--##########################################################################--
--[[----------------------------------------------------------------------]]--
--     DRAW
--[[----------------------------------------------------------------------]]--
--##########################################################################--
function level1_game_state.draw()
  local level = state.level
  local camera = level:get_camera()
  
  if lk.isDown("k") then
  level:draw()
  end

  camera:set()
  state.hero:draw()
  camera:unset()
  
end

return level1_game_state














